osgManipulator::LineProjector Class Reference

`#include <Projector>`

Inheritance diagram for osgManipulator::LineProjector:

## Public Member Functions

| LineProjector ()
| LineProjector (const osg::LineSegment::vec_type &s, const osg::LineSegment::vec_type &e)
void | setLine (const osg::LineSegment::vec_type &s, const osg::LineSegment::vec_type &e)
const osg::LineSegment::vec_type & | getLineStart () const
osg::LineSegment::vec_type & | getLineStart ()
const osg::LineSegment::vec_type & | getLineEnd () const
osg::LineSegment::vec_type & | getLineEnd ()
virtual bool | project (const PointerInfo &pi, osg::Vec3d &projectedPoint) const
Public Member Functions inherited from osgManipulator::Projector
| Projector ()
void | setLocalToWorld (const osg::Matrix &localToWorld)
const osg::Matrix & | getLocalToWorld () const
const osg::Matrix & | getWorldToLocal () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~LineProjector ()
Protected Member Functions inherited from osgManipulator::Projector
virtual | ~Projector ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< osg::LineSegment > | _line
Protected Attributes inherited from osgManipulator::Projector
osg::Matrix | _localToWorld
osg::Matrix | _worldToLocal
bool | _worldToLocalDirty
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

LineProjector projects points onto the closest point on the given line.

## Constructor & Destructor Documentation

## LineProjector() [1/2]

osgManipulator::LineProjector::LineProjector | ( |  | ) |

## LineProjector() [2/2]

osgManipulator::LineProjector::LineProjector | ( | const osg::LineSegment::vec_type & | s,
|  | const osg::LineSegment::vec_type & | e )

## ~LineProjector()

virtual osgManipulator::LineProjector::~LineProjector | ( |  | ) |

protected virtual

## Member Function Documentation

## getLineEnd() [1/2]

osg::LineSegment::vec_type & osgManipulator::LineProjector::getLineEnd | ( |  | ) |

inline

References _line.

## getLineEnd() [2/2]

const osg::LineSegment::vec_type & osgManipulator::LineProjector::getLineEnd | ( |  | ) | const

inline

References _line.

## getLineStart() [1/2]

osg::LineSegment::vec_type & osgManipulator::LineProjector::getLineStart | ( |  | ) |

inline

References _line.

## getLineStart() [2/2]

const osg::LineSegment::vec_type & osgManipulator::LineProjector::getLineStart | ( |  | ) | const

inline

References _line.

## project()

virtual bool osgManipulator::LineProjector::project | ( | const PointerInfo & | pi,
|  | osg::Vec3d & | projectedPoint ) const

virtual

Calculates the object coordinates (projectedPoint) of a window coordinate (pointToProject) when projected onto the given line. Returns true on successful projection.

Implements osgManipulator::Projector.

## setLine()

void osgManipulator::LineProjector::setLine | ( | const osg::LineSegment::vec_type & | s,
|  | const osg::LineSegment::vec_type & | e )

inline

References _line.

## Member Data Documentation

## _line

osg::ref_ptr<osg::LineSegment> osgManipulator::LineProjector::_line

protected

Referenced by getLineEnd(), getLineEnd(), getLineStart(), getLineStart(), and setLine().

The documentation for this class was generated from the following file:

- Projector